VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Lib_Spell"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'-----------------------------------------------------------------------------
'-- Class Name: Encapsulator For Spell Checking
'-- Created   : 19-07-2002
'-- Author    : Gary Noble
'-- Copyright : Gary Noble 2002
'-----------------------------------------------------------------------------
Public Event BeforeChange(bCancel As Boolean)
Public Event BeforeAdd(bCancel As Boolean)
Public Event BeforeSave(bCancel As Boolean)
Public Event BeforeIgnore(bCancel As Boolean) '-- not called
Public Event CompleteSpellCheck()
Private WithEvents frmSpellCheck As frmCheck
Attribute frmSpellCheck.VB_VarHelpID = -1
Private bLoadedWords As Boolean

'-- Properties

'-- Show window on top?
Public Property Let ShowOnTop(ByVal vData As Boolean)
    m_ShowOnTop = vData
    frmSpellCheck.SetPosition
End Property
Public Property Get ShowOnTop() As Boolean
    ShowOnTop = m_ShowOnTop
End Property
'-- returns the handle of the Spell Checker window
Public Property Let WindowhWnd(ByVal hWnd As Long)
    hWnd = frmCheck.hWnd
End Property
'-- Returns a reference to the actual form
'-- has to be declared as object - vb does not allow the use of form in this case
Public Property Get SpellCheckerForm() As Object
    Set SpellCheckerForm = frmSpellCheck
End Property
'-- Dictionary path
Public Property Let Dictionary(ByVal vData As String)
    If m_Dictionary <> vData And m_Dictionary <> "" Then
        SaveDictIfNeeded
    End If
    m_Dictionary = vData
End Property
Public Property Get Dictionary() As String
    Dictionary = m_Dictionary
End Property
'-- Allow adding to dictionary?
Public Property Let AllowAdd(ByVal vData As Boolean)
    frmSpellCheck.cmdAdd.Enabled = vData
End Property
Public Property Get AllowAdd() As Boolean
    AllowAdd = frmSpellCheck.cmdAdd.Enabled
End Property
'-- Set the caption of the window
Public Property Let SpellCaption(ByVal vData As String)
    frmSpellCheck.Caption = vData
End Property
Public Property Get SpellCaption() As String
    SpellCaption = frmSpellCheck.Caption
End Property
'-- set the TextBox/RichTextBox to check
Public Property Set TextBox(ByVal vData As Object)
    '-- useless
    On Error Resume Next
    IIf vData.Text = "", True, False
    If Err Then
        Err.Raise vbObjectError + 5000, "Spell Checker", "Invalid TextBox object."
    Else
        Set m_TextBox = vData
    End If
End Property
Public Property Get TextBox() As Object
    Set TextBox = m_TextBox
End Property
'-- Events
Private Sub frmSpellCheck_BeforeAdd(bCancel As Boolean)
    RaiseEvent BeforeAdd(bCancel)
End Sub
Private Sub frmSpellCheck_BeforeChange(bCancel As Boolean)
    RaiseEvent BeforeChange(bCancel)
End Sub

Private Sub frmSpellCheck_BeforeSave()
    SaveDictIfNeeded
End Sub

Private Sub frmSpellCheck_CompleteSpellCheck()
    RaiseEvent CompleteSpellCheck
End Sub
'-- Procedures
Public Sub SpellCheck(ByVal bFromStart As Boolean)
    If Not bLoadedWords Then
        LoadWords Dictionary
        bLoadedWords = True
    End If
    If bFromStart Then
        TextBox.SelStart = 0
    End If
    frmSpellCheck.SpellCheck TextBox
    
End Sub
Public Sub AddCustomItem(ByVal sItem As String)
    If frmSpellCheck.AddItem(LCase$(sItem), False) = False Then
        Err.Raise vbObjectError + 5001, "Spell Checker", "That item already exists in the dictionary"
    End If
End Sub
Public Sub LoadDictionary()
    LoadWords Dictionary
End Sub
Public Sub SaveDictionary()
    SaveWords Dictionary
End Sub
'-- Class
Private Sub Class_Initialize()
    Set frmSpellCheck = New frmCheck
    '-- set the default dictionary
    Dictionary = App.Path & "\dictionary.txt"
    '-- initialise the WordsToAdd array
    ReDim WordsToAdd(0)
    '-- Set default properties
    m_ShowOnTop = True
End Sub

Private Sub Class_Terminate()
    Unload frmSpellCheck
End Sub
Private Sub SaveDictIfNeeded()
    Dim bCancel As Boolean
    If Forms.Count = 0 Then Exit Sub
    If frmSpellCheck.bDictChanged Then
        RaiseEvent BeforeSave(bCancel)
        If Not bCancel Then SaveWords Dictionary
    End If
End Sub

